#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Aug  7 21:09:43 2017

@author: andres
"""

# Ejemplo de regresion lineal

import tensorflow as tf
import numpy as np
import matplotlib.pyplot as plt



# Datos 
train_X = np.asarray([3.3,4.4,5.5,6.71,6.93,4.168,9.779,6.182,7.59,2.167,
                         7.042,10.791,5.313,7.997,5.654,9.27,3.1])
train_Y = np.asarray([1.7,2.76,2.09,3.19,1.694,1.573,3.366,2.596,2.53,1.221,
                         2.827,3.465,1.65,2.904,2.42,2.94,1.3])
# Parametros

learning_rate = 0.001
train_iters = 100

data=np.hstack((train_X.reshape(-1,1),train_Y.reshape(-1,1)))
n_samples=data.shape[0]
# En la primera columna de data est´an los predictores X y en la segunda las respuestas Y


# Crear los ***  para almacenar X, Y


# Crear los *** para almacenar w, b


# Modelo: Y=wX+b
Y_predicted = X * w + b 

# Definir funcion de perdida cuadratica 


# Definicion del optimizador: gradiente descendente
optimizer = tf.train.GradientDescentOptimizer(learning_rate=learning_rate).minimize(loss)

# Definicion de la sesion -> operaciones a ejecutar dentro de la sesion
with tf.Session() as sess:
	# Inicializacion de las variables w, b
	sess.run(tf.global_variables_initializer()) 
		
	# Entrenamiento
	for i in range(training_iters): # 100 iteraciones
		total_loss = 0
		for x, y in data:
			# Ejecutar el optimizador en esta iteracion (sess.run) (la perdida la llamamos l)

			total_loss += l
		print ('Iteracion %d, Mean loss=%1.2f'%(i, total_loss/n_samples))
	
	#Muestra los valores finales de w, b
	w_value, b_value = sess.run([w, b])
    
#Grafico
X, Y = data.T[0], data.T[1]
plt.plot(X, Y, 'bo', label='Datos reales')
plt.xlabel('Predictor')
plt.ylabel('Respuesta')
plt.savefig('muestras_regresion.png')
plt.plot(X, X * w_value + b_value, 'r', label='Prediccion')
plt.legend()
plt.show()